/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Jaap Haitsma.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Tracy Norris (tnorris@nc.rr.com), Jesper Kristensen (jesper@nc.rr.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
function TestAssist(filename){
	this.commands;
	this.currentCommand;
	this.filename = filename;
	this.running = true;
	this.canceled = false;
	this.checkLoadURL = '';
	this.checkLoadTimeout = 0;
	var browser = document.getElementById("content");
	this.targetWindow = browser.browsers[browser.mTabBox.selectedIndex].contentWindow
	this.targetWindow.testAssist = this;
	this.parseFile();
}

TestAssist.prototype.parseFile = function(){
	try{
		var oFile = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		oFile.initWithPath( this.filename );
		var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance( Components.interfaces.nsIFileInputStream );
		is.init( oFile,0x01, 00004, null);
		is.QueryInterface(Components.interfaces.nsILineInputStream);
		var line = {};
		this.commands = new Array();
		this.currentCommand = 0;
		do {
			hasmore = is.readLine(line);
			var cleanedLine = line.value.replace( /^\s+/g, "" );// strip leading
  		cleanedLine = cleanedLine.replace( /\s+$/g, "" );// strip trailing
			consoleDump('Adding command ' + cleanedLine);
			if(cleanedLine.length > 0)
				this.commands[this.commands.length] = new TestCommand(cleanedLine);
		} while(hasmore);
		is.close();
	}catch(ex){
		alert(ex);
	}
}

TestAssist.prototype.startTest = function(){
	this.currentCommand = 0;
	this.running = true;
	this.canceled = false;
	this.targetWindow.setTimeout('this.testAssist.continueTest()', 1000);
}

TestAssist.prototype.continueTest = function(){
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
		.getService(Components.interfaces.nsIPromptService);

	consoleDump('continueTest starting running = ' + this.running + ', canceled = ' + this.canceled);
	if(this.canceled || !this.running)
		return;

	if(this.currentCommand >= this.commands.length){
		this.running = false;
		this.canceled = true;
		alert("Completed test!");
		return;
	}

	try{
		if(!this.execCommand(this.commands[this.currentCommand])){
				this.canceled = !promptService.confirm(window, "Continue Test?", "Click OK to continue running the test");
		}
		this.currentCommand++;
	}catch(ex){
		alert(ex);
		this.canceled = !promptService.confirm(window, "Continue Test?", "Click OK to continue running the test");
	}	

	consoleDump('continueTest checking status running = ' + this.running + ', canceled = ' + this.canceled);
	if(this.running && !this.canceled){
		this.continueTest();
	}

}

TestAssist.prototype.loadHandler = function(event){
	try{
		consoleDump('loadHandler: Received event.');
		var browser = document.getElementById("content");
		var oWindow = browser.browsers[browser.mTabBox.selectedIndex].contentWindow
		consoleDump('loadHandler: current href ' + oWindow.location.href);
		consoleDump('loadHandler: stored href ' + curTest.checkLoadURL);
		if(oWindow.location.href.toLowerCase() == curTest.checkLoadURL.toLowerCase()){
			consoleDump('loadHandler: restarting test');
			curTest.running = true;
			parent.removeEventListener('load', this.loadHandler, true);
			curTest.targetWindow.clearTimeout(curTest.checkLoadTimeoutHandle);
			setTimeout('curTest.continueTest()', 2000);
		}
	}catch(ex){
		alert("Error in loadhandler:\n" + ex);
	}
	return true;
}

TestAssist.prototype.loadTimeoutHandler = function(){
	if(curTest.canceled)
		return;

	consoleDump('loadTimeoutHandler: Checking timeout');
	var now = new Date();
	if(now.getTime() >= curTest.checkLoadTimeout){
		alert('Timeout waiting for page to load on command #' + (curTest.currentCommand + 1));
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService);
		curTest.canceled = !promptService.confirm(window, "Continue Test?", "Click OK to continue running the test");
		curTest.running = true;
		setTimeout('curTest.continueTest()', 2000);
	}else{
		consoleDump('loadTimeoutHandler: Reseting timer');
		curTest.checkLoadTimeoutHandle = setTimeout('curTest.loadTimeoutHandler()', 1000);
	}	
}

TestAssist.prototype.wakeup = function(){
	this.running = true;
	curTest.continueTest();
}

TestAssist.prototype.execCommand = function(command){
	var browser = document.getElementById("content");
	var oWindow = browser.browsers[browser.mTabBox.selectedIndex].contentWindow
	consoleDump("execCommand: " + command.commandName);
	var box = oWindow.document.getBoxObjectFor(oWindow.document.documentElement);
	var screenDelta = { x: box.screenX, y: box.screenY };

	switch(command.commandName){
		case 'check_load':
			parent.addEventListener('load', this.loadHandler, true);
			oWindow.status = "Waiting for page to load " + command.params[0];
			var now = new Date();
			if(command.params.length > 1){
				this.checkLoadTimeout = now.getTime() + (command.params[1] * 1000);
			}else{
				this.checkLoadTimeout = now.getTime() + 15000; // 15 second timeout
			}
			this.running = false;
			this.checkLoadURL = command.params[0];
			oWindow.testAssist = this;
			consoleDump("check_load handler: " + this.loadHandler);
			curTest.checkLoadTimeoutHandle = setTimeout('curTest.loadTimeoutHandler()', 1000);
			oWindow.location.href = command.params[0];
			return true;
		
		case 'load':
			oWindow.status = "Loading URL " + command.params[0];
			oWindow.location.href = command.params[0];
			this.execCommand(new TestCommand('check_load:' + command.params[0]));
			return true;
		
		case 'sleep':
			oWindow.status = "Sleeping for " + command.params[0] + " seconds";
			this.running = false;
			setTimeout('curTest.wakeup()', command.params[0] * 1000);
			return true;
		
		case 'focus':
			curElm = oWindow.document.getElementById(command.params[0]);
			if(!curElm){
				alert('Could not find element with ID ' + command.params[0]);
				return false;
			}else{
				curElm.focus();
			}
			return true;

		case 'focus_xpath':
			var elements = oWindow.document.evaluate(command.params[0], oWindow.document, null, XPathResult.ANY_TYPE,null);
			consoleDump(elements);
			curElm = elements.iterateNext();
			if(curElm && elements.iterateNext()){
				alert("Found too many elements for xpath:\n" + command.params[0]);
				return false;
			}else if(!curElm){
				alert("Could not find element for xpath:\n" + command.params[0]);
				return false;
			}
			if(!curElm){
				alert('Could not find element with XPath:\n' + command.params[0]);
				return false;
			}else{
				curElm.focus();
			}
			return true;

		case 'click':
			var x = command.params[0];
			var y = command.params[1];
			var evt = oWindow.document.createEvent("MouseEvents");
			evt.initMouseEvent('click', true, true, oWindow.document.defaultView, 
				0, x + screenDelta.x, y + screenDelta.y, x, y,
				false, false, false, false, command.params[1], null);
			if(curElm){
				curElm.dispatchEvent(evt);
			}else{
				oWindow.document.body.dispatchEvent(evt);
			}
			return true;

		case 'mouseup':
			var x = command.params[0];
			var y = command.params[1];
			var evt = oWindow.document.createEvent("MouseEvents");
			evt.initMouseEvent('mouseup', true, true, oWindow.document.defaultView, 
				0, x + screenDelta.x, y + screenDelta.y, x, y,
				false, false, false, false, command.params[1], null);
			if(curElm){
				curElm.dispatchEvent(evt);
			}else{
				oWindow.document.body.dispatchEvent(evt);
			}
			return true;

		case 'mousedown':
			var x = command.params[0];
			var y = command.params[1];
			var evt = oWindow.document.createEvent("MouseEvents");
			evt.initMouseEvent('mousedown', true, false, oWindow.document.defaultView, 
				0, x + screenDelta.x, y + screenDelta.y, x, y,
				false, false, false, false, command.params[1], null);
			if(curElm){
				curElm.dispatchEvent(evt);
			}else{
				oWindow.document.body.dispatchEvent(evt);
			}
			return true;

		case 'keyup':
			var evt = oWindow.document.createEvent("KeyEvents");
			evt.initKeyEvent("keyup", true, true, oWindow.document.defaultView,
				command.params[0] == 'true', command.params[1] == 'true', 
				command.params[2] == 'true', command.params[3] == 'true', 
				command.params[4], command.params[5]) 
			if(curElm){
				curElm.dispatchEvent(evt);
			}else{
				oWindow.document.body.dispatchEvent(evt);
			}
			return true;

		case 'keydown':
			var evt = oWindow.document.createEvent("KeyEvents");
			evt.initKeyEvent("keydown", true, true, oWindow.document.defaultView,
				command.params[0] == 'true', command.params[1] == 'true', 
				command.params[2] == 'true', command.params[3] == 'true',
				command.params[4], command.params[5]) 
			if(curElm){
				curElm.dispatchEvent(evt);
			}else{
				oWindow.document.body.dispatchEvent(evt);
			}
			return true;

		case 'keypress':
			var evt = oWindow.document.createEvent("KeyEvents");
			evt.initKeyEvent("keypress", true, true, oWindow.document.defaultView,
				command.params[0] == 'true', command.params[1] == 'true',
				command.params[2] == 'true', command.params[3] == 'true',
				command.params[4], command.params[5]) 
			if(curElm){
				curElm.dispatchEvent(evt);
			}else{
				oWindow.document.body.dispatchEvent(evt);
			}
			return true;


		default:
			alert("Unknown command " + command.commandName);
			return false;
	}
}

function TestCommand(line){
	this.line = line;
	this.commandName = '';
	this.params = new Array();
	this.parseLine();
}

TestCommand.prototype.parseLine = function(){
	this.commandName = this.line.substring(0, this.line.indexOf(':'));
	var param_string = this.line.substring(this.line.indexOf(':') + 1, this.line.length);
	this.params = param_string.split(',');
}
