/* ***** BEGIN LICENSE BLOCK ***** 
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Jaap Haitsma.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Tracy Norris (tnorris@nc.rr.com), Jesper Kristensen (jesper@nc.rr.com)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var autofillProfileName=new Array();

var autofillTitle=new Array();
var autofillFirstName=new Array();
var autofillMiddleName=new Array();
var autofillLastName=new Array();
var autofillSuffix=new Array();
var autofillEmailAddress=new Array();
var autofillPhoneNumber=new Array();

var autofillPrimaryLine1=new Array();
var autofillPrimaryLine2=new Array();
var autofillPrimaryCity=new Array();
var autofillPrimaryState=new Array();
var autofillPrimaryZip=new Array();
var autofillPrimaryCountryCode=new Array();

var autofillUsePrimary=new Array();

var autofillSecondaryLine1=new Array();
var autofillSecondaryLine2=new Array();
var autofillSecondaryCity=new Array();
var autofillSecondaryState=new Array();
var autofillSecondaryZip=new Array();
var autofillSecondaryCountryCode=new Array();

var autofillCardName=new Array();
var autofillCardType=new Array();
var autofillCardNumber=new Array();
var autofillCardVerification=new Array();
var autofillCardExpMonth=new Array();
var autofillCardExpDay=new Array();
var autofillCardExpYear=new Array();

var daysInMonth=new Array(31,28,31,30,31,30,31,31,30,31,30,31);

var cardNumberLengths=new Array();
cardNumberLengths["AMER"]=new Array("15");
cardNumberLengths["DINE"]=new Array("14");
cardNumberLengths["DC"]=new Array("14");
cardNumberLengths["DISC"]=new Array("16");
cardNumberLengths["JCB"]=new Array("15","16");
cardNumberLengths["MAST"]=new Array("16");
cardNumberLengths["VISA"]=new Array("13","16");

var cardNumberPrefixes=new Array();
cardNumberPrefixes["AMER"]=new Array("34","37");
cardNumberPrefixes["DINE"]=new Array("300","301","302","303","304","305","36","38");
cardNumberPrefixes["DC"]=new Array("300","301","302","303","304","305","36","38");
cardNumberPrefixes["DISC"]=new Array("6011");
cardNumberPrefixes["JCB"]=new Array("3","2131","1800");
cardNumberPrefixes["MAST"]=new Array("51","52","53","54","55");
cardNumberPrefixes["VISA"]=new Array("4");


function usePrimaryListener() {
	if (document.getElementById('use_primary').checked) {
		document.getElementById('autofill_secondary_line1').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_line2').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_city').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_state').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_zip').setAttribute("disabled","true");
		document.getElementById('autofill_secondary_country').setAttribute("disabled","true");
	}
	else {
		document.getElementById('autofill_secondary_line1').removeAttribute("disabled");
		document.getElementById('autofill_secondary_line2').removeAttribute("disabled");
		document.getElementById('autofill_secondary_city').removeAttribute("disabled");
		document.getElementById('autofill_secondary_state').removeAttribute("disabled");
		document.getElementById('autofill_secondary_zip').removeAttribute("disabled");
		document.getElementById('autofill_secondary_country').removeAttribute("disabled");
	}

	// Save Use Primary Checkbox
	autofillUsePrimary[document.getElementById("profile_menu").selectedIndex]=document.getElementById("use_primary").checked;

}

function doOK() {
	
	if (autofillPrefs.prefHasUserValue("selected_profile_id"))
		selectedProfileId=autofillPrefs.getCharPref("selected_profile_id");
	else
		selectedProfileId="";
	
	deleteProfilePreferences();
	
	// Options
	autofillPrefs.setBoolPref("autohighlight",document.getElementById("autofill_autohighlight").checked);

	var profileString="";
	var found=false;
	
	for (var i=0;i<autofillProfileName.length;++i) {
	
		// is the selected profile in the list of profiles?
		if (selectedProfileId==autofillProfileName[i])
			found=true;
			
		profileString += autofillProfileName[i];
		profileString += ",";
		
		// General Elements
		autofillPrefs.setCharPref(autofillProfileName[i]+".title",autofillTitle[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".first_name",autofillFirstName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".middle_name",autofillMiddleName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".last_name",autofillLastName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".suffix",autofillSuffix[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".email_address",autofillEmailAddress[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".phone_number",autofillPhoneNumber[i]);

		// Primary Address
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_line1",autofillPrimaryLine1[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_line2",autofillPrimaryLine2[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_city",autofillPrimaryCity[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_state",autofillPrimaryState[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_zip",autofillPrimaryZip[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".primary_country_code",autofillPrimaryCountryCode[i]);
		
		if (autofillPrimaryCountryCode[i]!="")
			autofillPrefs.setCharPref(autofillProfileName[i]+".primary_country",countries[autofillPrimaryCountryCode[i]]);
		else
			autofillPrefs.setCharPref(autofillProfileName[i]+".primary_country","");
		

		// Use Primary Address
		autofillPrefs.setBoolPref(autofillProfileName[i]+".use_primary",autofillUsePrimary[i]);

		// Secondary Address
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_line1",autofillSecondaryLine1[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_line2",autofillSecondaryLine2[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_city",autofillSecondaryCity[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_state",autofillSecondaryState[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_zip",autofillSecondaryZip[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_country_code",autofillSecondaryCountryCode[i]);
		
		if (autofillSecondaryCountryCode[i]!="")
			autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_country",countries[autofillSecondaryCountryCode[i]]);
		else
			autofillPrefs.setCharPref(autofillProfileName[i]+".secondary_country","");			

		// Credit Card Details
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_name",autofillCardName[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_type",autofillCardType[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_number",autofillCardNumber[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_verification",autofillCardVerification[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_exp_month",autofillCardExpMonth[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_exp_day",autofillCardExpDay[i]);
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_exp_year",autofillCardExpYear[i]);

	}
	
	// if the selected profile is in the list or there is only one profile, set it accordingly, otherwise reset it
	if (found)
		autofillPrefs.setCharPref("selected_profile_id",selectedProfileId);
	else if (autofillProfileName.length==1)
		autofillPrefs.setCharPref("selected_profile_id",autofillProfileName[0]);
	else
		autofillPrefs.setCharPref("selected_profile_id","");
		
	// lop off the last comma
	profileString=profileString.substring(0,profileString.length-1);
	
	autofillPrefs.setCharPref("profile_list",profileString);
		
	return true;
}

function deleteProfilePreferences() {
	if (autofillPrefs.prefHasUserValue("profile_list")) {
		var profileList=autofillPrefs.getCharPref("profile_list");
		
		if (profileList.length>0) {
			var profiles=profileList.split(",");
			
			for (var i=0;i<profiles.length;++i) {
				autofillPrefs.deleteBranch(profiles[i]);
			}
		}
	}
	
}

function doCancel() {
	return true;
}

function doHelp() {
	window.open("http://autofill.mozdev.org/help.html");
	return true;
}

function autofillPrefLoadSettings() {

	populateCountryMenu(document.getElementById("autofill_primary_country"));
	populateCountryMenu(document.getElementById("autofill_secondary_country"));

	// Assume if autohighlight preference is set, that all the remaining preferences are set
	if (autofillPrefs.prefHasUserValue("autohighlight")) {
		document.getElementById("autofill_autohighlight").checked=autofillPrefs.getBoolPref("autohighlight");

		var profileList=autofillPrefs.getCharPref("profile_list");

		if (profileList.length>0) {
			// parse the profile list for each profile
			profiles=profileList.split(",");

			// iterate over the profiles and populate the arrays & attribute fields
			for (var i=0;i<profiles.length;++i) {
				// populate the profile select drop down
				document.getElementById("profile_menu").appendItem(profiles[i],profiles[i]);
				autofillProfileName[i]=profiles[i];

				if (i==0) {
					// Select the First Profile
					document.getElementById("profile_menu").selectedIndex=0;

					// Populate the text boxs w/ the first profile
					document.getElementById("autofill_title").value=autofillPrefs.getCharPref(profiles[i]+".title");
					document.getElementById("autofill_first_name").value=autofillPrefs.getCharPref(profiles[i]+".first_name");
					document.getElementById("autofill_middle_name").value=autofillPrefs.getCharPref(profiles[i]+".middle_name");
					document.getElementById("autofill_last_name").value=autofillPrefs.getCharPref(profiles[i]+".last_name");
					document.getElementById("autofill_suffix").value=autofillPrefs.getCharPref(profiles[i]+".suffix");
					document.getElementById("autofill_email_address").value=autofillPrefs.getCharPref(profiles[i]+".email_address");
					document.getElementById("autofill_phone_number").value=autofillPrefs.getCharPref(profiles[i]+".phone_number");

					document.getElementById("autofill_primary_line1").value=autofillPrefs.getCharPref(profiles[i]+".primary_line1");
					document.getElementById("autofill_primary_line2").value=autofillPrefs.getCharPref(profiles[i]+".primary_line2");
					document.getElementById("autofill_primary_city").value=autofillPrefs.getCharPref(profiles[i]+".primary_city");
					document.getElementById("autofill_primary_state").value=autofillPrefs.getCharPref(profiles[i]+".primary_state");
					document.getElementById("autofill_primary_zip").value=autofillPrefs.getCharPref(profiles[i]+".primary_zip");

					consoleDump("use_primary: " + profiles[i] + ":" + i);
					
					selectedPrimaryCountryCode=autofillPrefs.getCharPref(profiles[i]+".primary_country_code");
					selectMenuItem(document.getElementById("autofill_primary_country"),selectedPrimaryCountryCode);
					
						
					consoleDump("use_primary1: " + profiles[i] + ":" + i);
					document.getElementById("use_primary").checked=autofillPrefs.getBoolPref(profiles[i]+".use_primary");
					usePrimaryListener();

					document.getElementById("autofill_secondary_line1").value=autofillPrefs.getCharPref(profiles[i]+".secondary_line1");
					document.getElementById("autofill_secondary_line2").value=autofillPrefs.getCharPref(profiles[i]+".secondary_line2");
					document.getElementById("autofill_secondary_city").value=autofillPrefs.getCharPref(profiles[i]+".secondary_city");
					document.getElementById("autofill_secondary_state").value=autofillPrefs.getCharPref(profiles[i]+".secondary_state");
					document.getElementById("autofill_secondary_zip").value=autofillPrefs.getCharPref(profiles[i]+".secondary_zip");

					selectedSecondaryCountryCode=autofillPrefs.getCharPref(profiles[i]+".secondary_country_code");
					selectMenuItem(document.getElementById("autofill_secondary_country"),selectedSecondaryCountryCode);					
				}

				// populate the arrays
				autofillTitle[i]=autofillPrefs.getCharPref(profiles[i]+".title");
				autofillFirstName[i]=autofillPrefs.getCharPref(profiles[i]+".first_name");
				autofillMiddleName[i]=autofillPrefs.getCharPref(profiles[i]+".middle_name");
				autofillLastName[i]=autofillPrefs.getCharPref(profiles[i]+".last_name");
				autofillSuffix[i]=autofillPrefs.getCharPref(profiles[i]+".suffix");
				autofillEmailAddress[i]=autofillPrefs.getCharPref(profiles[i]+".email_address");
				autofillPhoneNumber[i]=autofillPrefs.getCharPref(profiles[i]+".phone_number");

				autofillPrimaryLine1[i]=autofillPrefs.getCharPref(profiles[i]+".primary_line1");
				autofillPrimaryLine2[i]=autofillPrefs.getCharPref(profiles[i]+".primary_line2");
				autofillPrimaryCity[i]=autofillPrefs.getCharPref(profiles[i]+".primary_city");
				autofillPrimaryState[i]=autofillPrefs.getCharPref(profiles[i]+".primary_state");
				autofillPrimaryZip[i]=autofillPrefs.getCharPref(profiles[i]+".primary_zip");
				autofillPrimaryCountryCode[i]=autofillPrefs.getCharPref(profiles[i]+".primary_country_code");

				autofillUsePrimary[i]=autofillPrefs.getBoolPref(profiles[i]+".use_primary");

				autofillSecondaryLine1[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_line1");
				autofillSecondaryLine2[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_line2");
				autofillSecondaryCity[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_city");
				autofillSecondaryState[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_state");
				autofillSecondaryZip[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_zip");
				autofillSecondaryCountryCode[i]=autofillPrefs.getCharPref(profiles[i]+".secondary_country_code");
				
				// account for upgrade from 0.1 to 0.2
				if (autofillPrefs.prefHasUserValue(profiles[i]+".card_name")) {
					autofillCardName[i]=autofillPrefs.getCharPref(profiles[i]+".card_name");
					autofillCardType[i]=autofillPrefs.getCharPref(profiles[i]+".card_type");
					autofillCardNumber[i]=autofillPrefs.getCharPref(profiles[i]+".card_number");
					autofillCardVerification[i]=autofillPrefs.getCharPref(profiles[i]+".card_verification");
					autofillCardExpMonth[i]=autofillPrefs.getCharPref(profiles[i]+".card_exp_month");
					autofillCardExpDay[i]=autofillPrefs.getCharPref(profiles[i]+".card_exp_day");
					autofillCardExpYear[i]=autofillPrefs.getCharPref(profiles[i]+".card_exp_year");
				}
				else {
					autofillCardName[i]="";
					autofillCardType[i]="";
					autofillCardNumber[i]="";
					autofillCardVerification[i]="";
					autofillCardExpMonth[i]="";
					autofillCardExpDay[i]="";
					autofillCardExpYear[i]="";
				}
			}
		}
		else {
			document.getElementById("del_profile").setAttribute("disabled","true");
			disableAllAttributes();
		}

	}
	else {
		document.getElementById("del_profile").setAttribute("disabled","true");
		disableAllAttributes();
	}
	
	// if password doesn't exists, show set password screen - is so, show enter/reset screen
	if (!autofillPrefs.prefHasUserValue("password")) {
		document.getElementById("autofill_card_deck").setAttribute("selectedIndex","0");
	}
	else {
		document.getElementById("autofill_card_deck").setAttribute("selectedIndex","1");
	}
}

// populate the Country DropDowns (the menulist, not the menupopup is passed in)
function populateCountryMenu(element) {
	var i=0;
	for (var aCountry in countries) {
		createMenuItem(element.firstChild,countries[aCountry],i,aCountry);
		++i;
	}
}

function createMenuItem(element,aLabel,anIndex,aValue) {
	var menuitem = document.createElement("menuitem");
	
	menuitem.setAttribute("label",aLabel);
	menuitem.setAttribute("index",anIndex);
	menuitem.setAttribute("value",aValue);
	
	element.appendChild(menuitem);
}


function enableAllAttributes() {
	document.getElementById("autofill_title").removeAttribute("disabled");
	document.getElementById("autofill_first_name").removeAttribute("disabled");
	document.getElementById("autofill_middle_name").removeAttribute("disabled");
	document.getElementById("autofill_last_name").removeAttribute("disabled");
	document.getElementById("autofill_suffix").removeAttribute("disabled");
	document.getElementById("autofill_email_address").removeAttribute("disabled");
	document.getElementById("autofill_phone_number").removeAttribute("disabled");

	document.getElementById("autofill_primary_line1").removeAttribute("disabled");
	document.getElementById("autofill_primary_line2").removeAttribute("disabled");
	document.getElementById("autofill_primary_city").removeAttribute("disabled");
	document.getElementById("autofill_primary_state").removeAttribute("disabled");
	document.getElementById("autofill_primary_zip").removeAttribute("disabled");
	document.getElementById("autofill_primary_country").removeAttribute("disabled");

	document.getElementById("use_primary").removeAttribute("disabled");

	document.getElementById("autofill_secondary_line1").removeAttribute("disabled");
	document.getElementById("autofill_secondary_line2").removeAttribute("disabled");
	document.getElementById("autofill_secondary_city").removeAttribute("disabled");
	document.getElementById("autofill_secondary_state").removeAttribute("disabled");
	document.getElementById("autofill_secondary_zip").removeAttribute("disabled");
	document.getElementById("autofill_secondary_country").removeAttribute("disabled");

	document.getElementById("autofill_card_name").removeAttribute("disabled");
	document.getElementById("autofill_card_type").removeAttribute("disabled");
	document.getElementById("autofill_card_number").removeAttribute("disabled");
	document.getElementById("autofill_card_verification").removeAttribute("disabled");
	document.getElementById("autofill_card_exp_month").removeAttribute("disabled");
	document.getElementById("autofill_card_exp_day").removeAttribute("disabled");
	document.getElementById("autofill_card_exp_year").removeAttribute("disabled");
}

function disableAllAttributes() {
	document.getElementById("autofill_title").setAttribute("disabled","true");
	document.getElementById("autofill_first_name").setAttribute("disabled","true");
	document.getElementById("autofill_middle_name").setAttribute("disabled","true");
	document.getElementById("autofill_last_name").setAttribute("disabled","true");
	document.getElementById("autofill_suffix").setAttribute("disabled","true");
	document.getElementById("autofill_email_address").setAttribute("disabled","true");
	document.getElementById("autofill_phone_number").setAttribute("disabled","true");

	document.getElementById("autofill_primary_line1").setAttribute("disabled","true");
	document.getElementById("autofill_primary_line2").setAttribute("disabled","true");
	document.getElementById("autofill_primary_city").setAttribute("disabled","true");
	document.getElementById("autofill_primary_state").setAttribute("disabled","true");
	document.getElementById("autofill_primary_zip").setAttribute("disabled","true");
	document.getElementById("autofill_primary_country").setAttribute("disabled","true");

	document.getElementById("use_primary").setAttribute("disabled","true");

	document.getElementById("autofill_secondary_line1").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_line2").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_city").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_state").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_zip").setAttribute("disabled","true");
	document.getElementById("autofill_secondary_country").setAttribute("disabled","true");		

	document.getElementById("autofill_card_name").setAttribute("disabled","true");
	document.getElementById("autofill_card_type").setAttribute("disabled","true");
	document.getElementById("autofill_card_number").setAttribute("disabled","true");
	document.getElementById("autofill_card_verification").setAttribute("disabled","true");
	document.getElementById("autofill_card_exp_month").setAttribute("disabled","true");
	document.getElementById("autofill_card_exp_day").setAttribute("disabled","true");
	document.getElementById("autofill_card_exp_year").setAttribute("disabled","true");
}


function doAddProfile() {
	// get a reference to the prompt service component.
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var profileObj = new Object();
	var checkObj = new Object();

	// prompt for the new profile name
	if(promptService.prompt(window,"Enter new profile name","Enter the name of the new profile", profileObj, null, checkObj)) {
		newProfileValue=profileObj.value;
	}
	else {
		return true;
	}

	var items=document.getElementById("profile_menu").firstChild.childNodes;
	
	if (newProfileValue.length>0) {
		// Don't allow "," and "." in profile name
		if (newProfileValue.indexOf(".")>-1||newProfileValue.indexOf(",")>-1) {
			return true;
		}
		
		// Don't allow duplicate profiles to be added
		for (var i=0;i<autofillProfileName.length;++i) {
			if (autofillProfileName[i]==newProfileValue) {
				return true;
			}
		}

		// If there are no profiles right now, reenable the attributes since they are currently cutoff
		if (items.length==0) {
			document.getElementById("del_profile").removeAttribute("disabled");
			enableAllAttributes();
		}
		
		// add the new profile to the list of profiles, and select it
		autofillProfileName[items.length]=newProfileValue;
		document.getElementById("profile_menu").appendItem(newProfileValue,newProfileValue);
		document.getElementById("profile_menu").selectedIndex=items.length;

		clearTextBoxes();

		// set empty array elements just in case user doesn't set any values (so doOK will work)
		clearArrayElements(items.length);


	}

	return true;
}

function clearArrayElements(i) {
	autofillTitle[i]="";
	autofillFirstName[i]="";
	autofillMiddleName[i]="";
	autofillLastName[i]="";
	autofillSuffix[i]="";
	autofillEmailAddress[i]="";
	autofillPhoneNumber[i]="";

	autofillPrimaryLine1[i]="";
	autofillPrimaryLine2[i]="";
	autofillPrimaryCity[i]="";
	autofillPrimaryState[i]="";
	autofillPrimaryZip[i]="";
	autofillPrimaryCountryCode[i]="";

	autofillUsePrimary[i]=false;

	autofillSecondaryLine1[i]="";
	autofillSecondaryLine2[i]="";
	autofillSecondaryCity[i]="";
	autofillSecondaryState[i]="";
	autofillSecondaryZip[i]="";
	autofillSecondaryCountryCode[i]="";

	autofillCardName[i]="";
	autofillCardType[i]="";
	autofillCardNumber[i]="";
	autofillCardVerification[i]="";
	autofillCardExpMonth[i]="";
	autofillCardExpDay[i]="";
	autofillCardExpYear[i]="";
}

function clearTextBoxes() {
	// Clear the General Elements
	document.getElementById("autofill_title").value="";
	document.getElementById("autofill_first_name").value="";
	document.getElementById("autofill_middle_name").value="";
	document.getElementById("autofill_last_name").value="";
	document.getElementById("autofill_suffix").value="";
	document.getElementById("autofill_email_address").value="";
	document.getElementById("autofill_phone_number").value="";

	// Clear Primary Address
	document.getElementById("autofill_primary_line1").value="";
	document.getElementById("autofill_primary_line2").value="";
	document.getElementById("autofill_primary_city").value="";
	document.getElementById("autofill_primary_state").value="";
	document.getElementById("autofill_primary_zip").value="";
	document.getElementById("autofill_primary_country").selectedIndex=-1;

	// Clear Use Primary Checkbox
	document.getElementById("use_primary").checked=false;
	usePrimaryListener();

	// Clear Secondary Address
	document.getElementById("autofill_secondary_line1").value="";
	document.getElementById("autofill_secondary_line2").value="";
	document.getElementById("autofill_secondary_city").value="";
	document.getElementById("autofill_secondary_state").value="";
	document.getElementById("autofill_secondary_zip").value="";
	document.getElementById("autofill_secondary_country").selectedIndex=-1;
	
	// Clear Credit Card
	document.getElementById("autofill_card_name").value="";
	document.getElementById("autofill_card_type").value="";
	document.getElementById("autofill_card_number").value="";
	document.getElementById("autofill_card_verification").value="";
	document.getElementById("autofill_card_exp_month").selectedIndex=-1;
	document.getElementById("autofill_card_exp_day").selectedIndex=-1;
	document.getElementById("autofill_card_exp_year").selectedIndex=-1;
	
}

function doDeleteProfile() {
	for (var i=document.getElementById("profile_menu").selectedIndex;i<(autofillProfileName.length-1);++i) {
		autofillProfileName[i]=autofillProfileName[i+1];

		autofillTitle[i]=autofillTitle[i+1];
		autofillFirstName[i]=autofillFirstName[i+1];
		autofillMiddleName[i]=autofillMiddleName[i+1];
		autofillLastName[i]=autofillLastName[i+1];
		autofillSuffix[i]=autofillSuffix[i+1];
		autofillEmailAddress[i]=autofillEmailAddress[i+1];
		autofillPhoneNumber[i]=autofillPhoneNumber[i+1];

		autofillPrimaryLine1[i]=autofillPrimaryLine1[i+1];
		autofillPrimaryLine2[i]=autofillPrimaryLine2[i+1];
		autofillPrimaryCity[i]=autofillPrimaryCity[i+1];
		autofillPrimaryState[i]=autofillPrimaryState[i+1];
		autofillPrimaryZip[i]=autofillPrimaryZip[i+1];
		autofillPrimaryCountryCode[i]=autofillPrimaryCountryCode[i+1];

		autofillUsePrimary[i]=autofillUsePrimary[i+1];

		autofillSecondaryLine1[i]=autofillSecondaryLine1[i+1];
		autofillSecondaryLine2[i]=autofillSecondaryLine2[i+1];
		autofillSecondaryCity[i]=autofillSecondaryCity[i+1];
		autofillSecondaryState[i]=autofillSecondaryState[i+1];
		autofillSecondaryZip[i]=autofillSecondaryZip[i+1];
		autofillSecondaryCountryCode[i]=autofillSecondaryCountryCode[i+1];
		
		autofillCardName[i]=autofillCardName[i+1];
		autofillCardType[i]=autofillCardType[i+1];
		autofillCardNumber[i]=autofillCardNumber[i+1];
		autofillCardVerification[i]=autofillCardVerification[i+1];
		autofillCardExpMonth[i]=autofillCardExpMonth[i+1];
		autofillCardExpDay[i]=autofillCardExpDay[i+1];
		autofillCardExpYear[i]=autofillCardExpYear[i+1];
	}
	
	autofillProfileName[autofillProfileName.length-1]="";
	autofillProfileName.length -= 1;

	clearArrayElements(autofillTitle.length-1);
	
	autofillTitle.length -= 1;
	autofillFirstName.length -= 1;
	autofillMiddleName.length -= 1;
	autofillLastName.length -= 1;
	autofillSuffix.length -= 1;
	autofillEmailAddress.length -= 1;
	autofillPhoneNumber.length -= 1;
	
	autofillPrimaryLine1.length -= 1;
	autofillPrimaryLine2.length -= 1;
	autofillPrimaryCity.length -= 1;
	autofillPrimaryState.length -= 1;
	autofillPrimaryZip.length -= 1;
	autofillPrimaryCountryCode.length -= 1;
	
	autofillUsePrimary.length -= 1;
	
	autofillSecondaryLine1.length -= 1;
	autofillSecondaryLine2.length -= 1;
	autofillSecondaryCity.length -= 1;
	autofillSecondaryState.length -= 1;
	autofillSecondaryZip.length -= 1;
	autofillSecondaryCountryCode.length -= 1;

	autofillCardName.length -= 1;
	autofillCardType.length -= 1;
	autofillCardNumber.length -= 1;
	autofillCardVerification.length -= 1;
	autofillCardExpMonth.length -= 1;
	autofillCardExpDay.length -= 1;
	autofillCardExpYear.length -= 1;

	var tempIndex=document.getElementById("profile_menu").selectedIndex;
	document.getElementById("profile_menu").removeItemAt(document.getElementById("profile_menu").selectedIndex);
	document.getElementById("profile_menu").selectedIndex=-1;
	
	if (tempIndex>=autofillProfileName.length) {
		if (autofillProfileName.length==0) {
			document.getElementById("del_profile").setAttribute("disabled","true");
			doProfileSelect();	
			disableAllAttributes();
		}
		else {
			document.getElementById("profile_menu").selectedIndex=autofillProfileName.length-1;
			doProfileSelect();	
		}
	}
	else {
		document.getElementById("profile_menu").selectedIndex=tempIndex;
		doProfileSelect();	
	}
	
	return true;
}

// populate "element" with the value passed, or empty it if value isn't set
function setTextAttribute(element,value) {
	if (value!=null) {
		element.value=value;
	}
	else {
		element.value="";
	}
}

function selectMenuItem(menulist,value) {
	menuitems=menulist.firstChild.childNodes;

	for (var i=0;i<menuitems.length;++i) {
		if (menuitems[i].getAttribute("value")==value) {
			menulist.selectedIndex=i;
			break;
		}
	}					
}

// populate the attributes with the values associated with the selected profile
function doProfileSelect() {
	
	// Load the text box values when a new profile is selected
	
	// Load General Settings
	setTextAttribute(document.getElementById("autofill_title"),autofillTitle[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_first_name"),autofillFirstName[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_middle_name"),autofillMiddleName[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_last_name"),autofillLastName[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_suffix"),autofillSuffix[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_email_address"),autofillEmailAddress[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_phone_number"),autofillPhoneNumber[document.getElementById("profile_menu").selectedIndex]);

	// Load Primary Address
	setTextAttribute(document.getElementById("autofill_primary_line1"),autofillPrimaryLine1[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_primary_line2"),autofillPrimaryLine2[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_primary_city"),autofillPrimaryCity[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_primary_state"),autofillPrimaryState[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_primary_zip"),autofillPrimaryZip[document.getElementById("profile_menu").selectedIndex]);
	selectMenuItem(document.getElementById("autofill_primary_country"),autofillPrimaryCountryCode[document.getElementById("profile_menu").selectedIndex]);

	// Load Use Primary Checkbox
	document.getElementById("use_primary").checked=autofillUsePrimary[document.getElementById("profile_menu").selectedIndex];
	usePrimaryListener();
	
	// Load Secondary Address
	setTextAttribute(document.getElementById("autofill_secondary_line1"),autofillSecondaryLine1[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_secondary_line2"),autofillSecondaryLine2[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_secondary_city"),autofillSecondaryCity[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_secondary_state"),autofillSecondaryState[document.getElementById("profile_menu").selectedIndex]);
	setTextAttribute(document.getElementById("autofill_secondary_zip"),autofillSecondaryZip[document.getElementById("profile_menu").selectedIndex]);
	selectMenuItem(document.getElementById("autofill_secondary_country"),autofillSecondaryCountryCode[document.getElementById("profile_menu").selectedIndex]);
		

	if (document.getElementById("autofill_card_deck").getAttribute("selectedIndex")==2) {
		loadCreditCardFields();
	}

	return true;
}


// Save the Profile Values each time a textbox loses focus (Can't wait till profile is complete because you've already lost
// which profile is currently selected by that time)
function saveProfileValues(event) {
	consoleDump("event: " + event.target.id + ":" + event.target.value);

	// Save General Settings
	if (event.target.id=="autofill_title") {
		autofillTitle[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_title").value;
	}
	
	if (event.target.id=="autofill_first_name") {
		autofillFirstName[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_first_name").value;
	}
	if (event.target.id=="autofill_middle_name") {
		autofillMiddleName[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_middle_name").value;
	}
	if (event.target.id=="autofill_last_name") {
		autofillLastName[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_last_name").value;
	}
	if (event.target.id=="autofill_suffix") {
		autofillSuffix[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_suffix").value;
	}
	if (event.target.id=="autofill_email_address") {
		autofillEmailAddress[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_email_address").value;
	}
	if (event.target.id=="autofill_phone_number") {
		autofillPhoneNumber[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_phone_number").value;
	}

	// Save Primary Address
	if (event.target.id=="autofill_primary_line1") {
		autofillPrimaryLine1[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_line1").value;
	}
	if (event.target.id=="autofill_primary_line2") {
		autofillPrimaryLine2[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_line2").value;
	}
	if (event.target.id=="autofill_primary_city") {
		autofillPrimaryCity[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_city").value;
	}
	if (event.target.id=="autofill_primary_state") {
		autofillPrimaryState[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_state").value;
	}
	if (event.target.id=="autofill_primary_zip") {
		autofillPrimaryZip[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_primary_zip").value;
	}

	// Save Secondary Address
	if (event.target.id=="autofill_secondary_line1") {
		autofillSecondaryLine1[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_line1").value;
	}
	if (event.target.id=="autofill_secondary_line2") {
		autofillSecondaryLine2[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_line2").value;
	}
	if (event.target.id=="autofill_secondary_city") {
		autofillSecondaryCity[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_city").value;
	}
	if (event.target.id=="autofill_secondary_state") {
		autofillSecondaryState[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_state").value;
	}
	if (event.target.id=="autofill_secondary_zip") {
		autofillSecondaryZip[document.getElementById("profile_menu").selectedIndex]=document.getElementById("autofill_secondary_zip").value;
	}

	// Credit Card Attributes
	if (event.target.id=="autofill_card_name") {
		consoleDump("CardName:" + rijndaelEncrypt(document.getElementById("autofill_card_name").value,autofillKey,"CBC") + ":" + autofillKey +":" + autofillPassword);
		autofillCardName[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(document.getElementById("autofill_card_name").value,autofillKey,"CBC"));
	}
	if (event.target.id=="autofill_card_number") {
		autofillCardNumber[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(document.getElementById("autofill_card_number").value,autofillKey,"CBC"));
	}
	if (event.target.id=="autofill_card_verification") {
		autofillCardVerification[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(document.getElementById("autofill_card_verification").value,autofillKey,"CBC"));
	}

}

function setCardType(event) {
		autofillCardType[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(event.target.value,autofillKey,"CBC"));
		consoleDump("Card Type: " + autofillCardType[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":");
}

function setCardExpMonth(event) {
		autofillCardExpMonth[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(event.target.value,autofillKey,"CBC"));
		populateExpDayMenu(document.getElementById("autofill_card_exp_day").firstChild,event.target.value,document.getElementById("autofill_card_exp_year").selectedItem.value);
		consoleDump("Card Month: " + autofillCardExpMonth[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":");
}

function setCardExpDay(event) {
		autofillCardExpDay[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(event.target.value,autofillKey,"CBC"));
		consoleDump("Card Day: " + autofillCardExpDay[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":");
}

function setCardExpYear(event) {
		autofillCardExpYear[document.getElementById("profile_menu").selectedIndex]=byteArrayToHex(rijndaelEncrypt(event.target.value,autofillKey,"CBC"));
		populateExpDayMenu(document.getElementById("autofill_card_exp_day").firstChild,document.getElementById("autofill_card_exp_month").selectedItem.value,event.target.value);
		consoleDump("Card Year: " + autofillCardExpYear[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":");
}

function setPrimaryCountryValues(event) {
		autofillPrimaryCountryCode[document.getElementById("profile_menu").selectedIndex]=event.target.value;
		consoleDump("Primary: " + autofillPrimaryCountryCode[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":" + countries[event.target.value]);
}

function setSecondaryCountryValues(event) {
		autofillSecondaryCountryCode[document.getElementById("profile_menu").selectedIndex]=event.target.value;
		consoleDump("Secondary: " + autofillSecondaryCountryCode[document.getElementById("profile_menu").selectedIndex] + ":" + event.target.value + ":" + countries[event.target.value]);
}

function setPassword() {
	window.openDialog("chrome://autofill/content/autofill_set_password.xul","autofill_set_password","chrome,centerscreen,modal",checkPasswordMatch);
}

// this method is just to set autofillPassword and autofillKey back in the prefences dialog scope.	
function checkPasswordMatch(setPassword,confirmPassword) {
	if (setPassword==confirmPassword) {
		if (setPassword.length>0) {
			autofillPrefs.setCharPref("password",hex_md5(setPassword));
			document.getElementById("autofill_card_deck").setAttribute("selectedIndex","2");
			autofillPassword=setPassword;
			createAutofillKey();
			loadCreditCardFields();
		}
	}
}

// actual accept autofill_set_password.xul handler
function doSetPasswordOK() {
	var setPassword=document.getElementById("set_password").value;
	var confirmPassword=document.getElementById("confirm_password").value;
	
	if (setPassword==confirmPassword) {
			return true;
	}
	else {
		alert("Passwords did not match");
		document.getElementById("set_password").value="";
		document.getElementById("confirm_password").value="";
		document.getElementById("set_password").focus();
		return false;
	}
	
}

function doAutofillPasswordCancel() {
	return true;
}


function resetPassword() {
	
	// eliminate the password, clear the credit card attributes, and reset to the 1st child in the deck
	autofillPrefs.deleteBranch("password");
	
	for (var i=0;i<autofillProfileName.length;++i) {
		// clear the preferences
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_name","");
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_type","");
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_number","");
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_verification","");
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_exp_month","");
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_exp_day","");
		autofillPrefs.setCharPref(autofillProfileName[i]+".card_exp_year","");

		// clear the card arrays
		autofillCardName[i]="";
		autofillCardType[i]="";
		autofillCardNumber[i]="";
		autofillCardVerification[i]="";
		autofillCardExpMonth[i]="";
		autofillCardExpDay[i]="";
		autofillCardExpYear[i]="";
	}
	
	
	// clear the current password
	autofillPassword=null;
	
	
	document.getElementById("autofill_card_deck").setAttribute("selectedIndex","0");
}

function enterPassword () {
	if (checkPassword()) {
		createAutofillKey();
		loadCreditCardFields();
		document.getElementById("autofill_card_deck").setAttribute("selectedIndex","2");
	}
		
}


function loadCreditCardFields() {
	selectedProfileIndex=document.getElementById("profile_menu").selectedIndex;
	if (selectedProfileIndex>-1) {
		setTextAttribute(document.getElementById("autofill_card_name"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardName[selectedProfileIndex]),autofillKey,"CBC")));

		if (autofillCardType[selectedProfileIndex]!="")
			selectMenuItem(document.getElementById("autofill_card_type"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardType[selectedProfileIndex]),autofillKey,"CBC")));
		else
			document.getElementById("autofill_card_type").selectedIndex=-1;

		setTextAttribute(document.getElementById("autofill_card_number"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardNumber[selectedProfileIndex]),autofillKey,"CBC")));
		setTextAttribute(document.getElementById("autofill_card_verification"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardVerification[selectedProfileIndex]),autofillKey,"CBC")));

		if (autofillCardExpMonth[selectedProfileIndex]!="")
			selectMenuItem(document.getElementById("autofill_card_exp_month"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardExpMonth[selectedProfileIndex]),autofillKey,"CBC")));
		else
			document.getElementById("autofill_card_exp_month").selectedIndex=-1;

		if (autofillCardExpYear[selectedProfileIndex]!="")
			selectMenuItem(document.getElementById("autofill_card_exp_year"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardExpYear[selectedProfileIndex]),autofillKey,"CBC")));
		else
			document.getElementById("autofill_card_exp_year").selectedIndex=-1;

		// if there is a month and a year selected, make the number of days right, otherwise default to january 2004
		if (document.getElementById("autofill_card_exp_month").selectedIndex>=0&&document.getElementById("autofill_card_exp_year").selectedIndex>=0) {
			populateExpDayMenu(document.getElementById("autofill_card_exp_day").firstChild,document.getElementById("autofill_card_exp_month").selectedItem.value,document.getElementById("autofill_card_exp_year").selectedItem.value);
		}
		else {
			populateExpDayMenu(document.getElementById("autofill_card_exp_day").firstChild,"1","2004");
		}

		if (autofillCardExpDay[selectedProfileIndex]!="")
			selectMenuItem(document.getElementById("autofill_card_exp_day"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardExpDay[selectedProfileIndex]),autofillKey,"CBC")));
		else
			document.getElementById("autofill_card_exp_day").selectedIndex=-1;

	}
}

function populateExpDayMenu(menupopup,monthNumber,year) {

	var selectedIndex=menupopup.parentNode.selectedIndex;
	
	var days=daysInMonth[monthNumber-1];
	consoleDump("ExpDay:" + year + ":" + days);
	
	if (monthNumber==2) {
		// get the leap years
		if (year % 4==0&&year % 100!=0||year % 400==0) {
			consoleDump("Setting Leap Year:" + monthNumber + ":" + year);
			days=days+1;
		}
	}
	
	// clear menu expects the popup
	clearMenu(menupopup);
	
	for (var i=0;i<days;++i) {
		createMenuItem(menupopup,i+1,i,i+1);
	}
	
	consoleDump("Resetting Day:" + i + ":" + selectedIndex);
	
	// continue to select the already selected day if it exists, otherwise switch to nothing selected
	if (i>=selectedIndex&&selectedIndex!=-1) {
		menupopup.parentNode.selectedIndex=selectedIndex;
	}
	else {
		menupopup.parentNode.selectedIndex=-1;
	}
}

function onShowExpDay(event) {
	consoleDump("showExpDay:" + document.getElementById("autofill_card_exp_month").selectItem.value + ":" + document.getElementById("autofill_card_exp_year").selectItem.value);
	
	populateExpDayMenu(event.target,document.getElementById("autofill_card_exp_month").selectItem.value,document.getElementById("autofill_card_exp_year").selectItem.value);	
}


function validateCreditCardNumber() {
	var cardNumber=stripNumber(document.getElementById("autofill_card_number").value);
	var cardType=document.getElementById("autofill_card_type").selectedItem.value;
	
	// check card number length
	var valid=false;
	var found=false;
	for (var aCardType in cardNumberLengths) {
		if (aCardType==cardType) {
			consoleDump("(Length)Found Card Type: " + aCardType + ":" + cardType);
			found=true;
			for (var i=0;i<cardNumberLengths[aCardType].length;++i) {
				if (cardNumber.length==cardNumberLengths[aCardType][i]) {
					consoleDump("Matched Length: " + cardNumber.length + ":" + cardNumberLengths[aCardType][i]);
					valid=true;
				}
			}	
		}
	}
	
	// Check Prefix
	if (valid) {
		for (var aCardType in cardNumberPrefixes) {
			if (aCardType==cardType) {
				consoleDump("(Prefix)Found Card Type: " + aCardType + ":" + cardType);
				found=true;
				for (var i=0;i<cardNumberPrefixes[aCardType].length;++i) {
					if (cardNumber.substr(0,cardNumberPrefixes[aCardType][i].length)==cardNumberPrefixes[aCardType][i]) {
						consoleDump("Matched Prefix: " + cardNumberPrefixes[aCardType][i]);
						valid=true;
					}
				}	
			}
		}
	}
	
	
	// Only check the LUHN if the card type is in the valid list, and is valid (thus far)
	if (found&&valid) {
		valid=false;  // reset valid
		var position=0;
		var checksum=0;
		for (var i=cardNumber.length-1;i>=0;--i) {
			var digit=parseInt(cardNumber.charAt(i));
			if (position % 2 == 1) {
				if (digit>4) {
					checksum = checksum + 1 + ((digit*2) % 10);
				}
				else {
					checksum=checksum+digit*2;
				}
			}
			else {
				checksum=checksum+digit;
			}
				
			consoleDump("checksum: " + i + ":" + position + ":" + checksum + ":" + digit);
			++position;
		}
		
		if (checksum % 10 == 0)
			valid=true;
	}
	
	if (found&&!valid) {
		// prompt to keep entered cardNumber
		consoleDump("prompting to keep");
		
		// get a reference to the prompt service component.
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		
		var result=promptService.confirmEx(window,"Invalid Credit Card Number","The credit card number you entered appears invalid.\nAre you sure you want to use this number?",
		(( promptService.BUTTON_POS_0 *  promptService.BUTTON_TITLE_YES) +
		( promptService.BUTTON_POS_1 *  promptService.BUTTON_TITLE_NO)),
		null,null,null,null,{});
		
		if (result==0) {
			consoleDump("Yes Clicked");
			return true;
		}
		else {
			consoleDump("No Clicked");
			// revert textbox
			setTextAttribute(document.getElementById("autofill_card_number"),byteArrayToString(rijndaelDecrypt(hexToByteArray(autofillCardNumber[selectedProfileIndex]),autofillKey,"CBC")));
			false;
		}
	}
	
	return true;
}
